﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace TestHarness
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void bn1_Click(object sender, RoutedEventArgs e)
        {
            
            BSSI.APLTools.Tools T = new BSSI.APLTools.Tools();
            
            if (!T.IsNumeric(tbxInt.Text))
            {
                MessageBox.Show("Interest% must be numeric");
            }
            else if (!T.IsNonNegativeInteger(tbxCurrAge.Text))
            {
                MessageBox.Show("Current Age must be a non-negative integer");
            }
            else if (!T.IsNonNegativeInteger(tbxRetAge.Text))
            {
                MessageBox.Show("Retirement Age must be a non-negative integer");
            }
            else if (!T.IsNumeric(tbxFundPV.Text))
            {
                MessageBox.Show("Fund Present Value must be numeric");
            }
            else
            {
                BSSI.Actl.Actl Vx = new BSSI.Actl.Actl();
                
                Int32 CA = Convert.ToInt32(T.StringToDouble(tbxCurrAge.Text));
                Int32 RA = Convert.ToInt32(T.StringToDouble(tbxRetAge.Text));
                Double Int = Convert.ToDouble(T.StringToDouble(tbxInt.Text));
                Double PV = Convert.ToDouble(T.StringToDouble(tbxFundPV.Text));
                double[] vx = Vx.Actl_Vx(T.SingletonToVector(1 + Math.Max(CA, RA), Int));
                Double AV = PV * vx[1 + CA] / vx[1 + RA];
                AV = T.RD(2, AV);
                tblkFundAV.Text = AV.ToString();
            }
        }
    }
}
